/*
 * Copyright 2004 The Apache Software Foundation.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package javax.faces.component;

import javax.faces.el.MethodBinding;
import javax.faces.event.ValueChangeListener;
import javax.faces.validator.Validator;

/**
 * @author Manfred Geiler (latest modification by $Author: mwessendorf $)
 * @version $Revision: 166994 $ $Date: 2004-07-02 00:12:40 +0200 (Fri, 02 Jul 2004) $
 */
public interface EditableValueHolder
        extends ValueHolder
{
    public Object getSubmittedValue();

    public void setSubmittedValue(Object submittedValue);

    public boolean isLocalValueSet();

    public void setLocalValueSet(boolean localValueSet);

    public boolean isValid();

    public void setValid(boolean valid);

    public boolean isRequired();

    public void setRequired(boolean required);

    public boolean isImmediate();

    public void setImmediate(boolean immediate);

    public MethodBinding getValidator();

    public void setValidator(javax.faces.el.MethodBinding validatorBinding);

    public MethodBinding getValueChangeListener();

    public void setValueChangeListener(MethodBinding valueChangeMethod);

    public void addValidator(Validator validator);

    public Validator[] getValidators();

    public void removeValidator(Validator validator);

    public void addValueChangeListener(ValueChangeListener listener);

    public ValueChangeListener[] getValueChangeListeners();

    public void removeValueChangeListener(ValueChangeListener listener);
}
