/*
 * Copyright 2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.myfaces.renderkit.html;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.render.Renderer;
import java.io.IOException;


/**
 * @author Manfred Geiler (latest modification by $Author: grantsmith $)
 * @version $Revision: 169655 $ $Date: 2005-05-11 18:45:06 +0200 (Wed, 11 May 2005) $
 */
public abstract class HtmlRenderer
        extends Renderer
{
    private static final Log log = LogFactory.getLog(HtmlRenderer.class);

    public void encodeChildren(FacesContext context, UIComponent component)
            throws IOException
    {
        if (log.isWarnEnabled())
        {
            if (getRendersChildren())
            {
                log.warn("Renderer " + getClass().getName() + " renders its children and should therefore implement encodeChildren.");
            }
            else
            {
                log.warn("Renderer " + getClass().getName() + " does not render its children. Method encodeChildren should not be called.");
            }
        }
    }
}
