/*
 * Copyright 2004 The Apache Software Foundation.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.myfaces.custom.aliasbean;

import javax.faces.component.UIComponent;

import org.apache.myfaces.taglib.UIComponentTagBase;

/**
 * @author Sylvain Vieujot (latest modification by $Author: svieujot $)
 * @version $Revision: 169189 $ $Date: 2005-05-09 01:03:38 +0200 (Mon, 09 May 2005) $
 */
public class AliasBeanTag extends UIComponentTagBase {

    private String _alias;
    private String _valueExpression;
    
    public void release() {
        super.release();

        _alias=null;
        _valueExpression=null;

    }
    
    protected void setProperties(UIComponent component) {
        super.setProperties(component);

        setStringProperty(component, "alias", _alias);
        setStringProperty(component, "value", _valueExpression);
    }
    
    public String getComponentType() {
        return AliasBean.COMPONENT_TYPE;
    }

    public String getRendererType() {
        return null;
    }
    
    public void setAlias(String alias){
        _alias = alias;
    }
    
    public void setValue(String valueExpression){
        _valueExpression = valueExpression;
    }
}