/*
 * Copyright 2004 The Apache Software Foundation.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.myfaces.custom.aliasbean;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.render.Renderer;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * @author Sylvain Vieujot (latest modification by $Author: svieujot $)
 * @version $Revision: 169189 $ $Date: 2005-05-09 01:03:38 +0200 (Mon, 09 May 2005) $
 */
public class AliasBeansScopeRenderer extends Renderer {
    private static final Log log = LogFactory.getLog(AliasBeansScopeRenderer.class);

    public void encodeBegin(FacesContext facesContext, UIComponent uiComponent) {
        log.debug("encodeBegin");

        AliasBeansScope aliasBeansScope = (AliasBeansScope) uiComponent;
		aliasBeansScope.makeAliases(facesContext);
    }
	
    public void encodeEnd(FacesContext facesContext, UIComponent uiComponent) {
        log.debug("encodeEnd");

		AliasBeansScope aliasBeansScope = (AliasBeansScope) uiComponent;
		aliasBeansScope.removeAliases(facesContext);
    }
}